/*
   MyClass.cc
   A sample dBL custom class from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2012. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 5 
   A class showing how PROTECT works to protect members of the class.
*/

class MyClass
   protect FirstName, Birthdate, Age
   this.FirstName = ""
   this.Birthdate = {} // empty date

   function Age()
      local dReturn
      dReturn = ( floor( ( val( dtos( date() ) ) ;
                   - val( dtos( this.Birthdate ) ) ) / 10000 ) )
   return dReturn

   function setFirstName( cName )
      this.FirstName := cName
   return

   function getFirstName
   return this.FirstName

   function setBirthdate( dDate )
      this.Birthdate := dDate
   return

   function getBirthdate
   return this.Birthdate

   function getAge
   return this.Age()

endclass